<?php

namespace App\Tools;

use App\Key\K;
use EasySwoole\Component\TableManager;
use Swlib\SaberGM;

class GSession
{
    public static function getSessionKey($content): string
    {
        $length = unpack('C', substr($content, 7, 1));
        return md5(substr($content, 8, current($length)));
    }

    public static function getSession($type){
        switch ($type) {
            case 'first':
                $table = TableManager::getInstance()->get(K::TABLE_FIRST_CACHE);
                break;
            case 'second':
                $table = TableManager::getInstance()->get(K::TABLE_SECOND_CACHE);
                break;
            default:
                throw new \Error('unknown type');
        }
        $count = $table->count();
        $index = 0;
        $needKey = $count > 0 ? time() % $count : 0;
        foreach ($table as $k => $v) {
            if ($needKey === $index) {
                $table->incr($k, 'sum');
                if ($type == 'first') {
//                    System::log(base64_decode($v['data']), 'return old first data ' . date('Y-m-d H:i:s'));
                }
                if ($type == 'second') {
//                    System::log(base64_decode($v['data']), 'return old second data ' . date('Y-m-d H:i:s'));
                }
                return base64_decode($v['data']);
            }
            $index++;
        }
//        System::log($type.' no  data return ',' table length is '.$count);
        $oldData = TableManager::getInstance()->get(K::TABLE_QUERY_LIST)->get('127.0.0.1');
        switch ($type) {
            case 'first':
                $defaultData = static::getDefaultQueryData('first');
                $oldData['first_time'] = time();
                $oldData['first_data'] = base64_encode($defaultData['data']);
                $oldData['first_header'] = json_encode($defaultData['headers'], JSON_UNESCAPED_SLASHES);
                TableManager::getInstance()->get(K::TABLE_SYSTEM_CONFIG)->del(K::KEY_FIRST_LAST_QUERY_TIME);
                break;
            case 'second':
                $defaultData = static::getDefaultQueryData('second');
                $oldData['second_time'] = time();
                $oldData['second_data'] = base64_encode($defaultData['data']);
                $oldData['second_header'] = json_encode($defaultData['headers'], JSON_UNESCAPED_SLASHES);
                TableManager::getInstance()->get(K::TABLE_SYSTEM_CONFIG)->del(K::KEY_SECOND_LAST_QUERY_FIRST_TIME);
                break;
        }
        TableManager::getInstance()->get(K::TABLE_QUERY_LIST)->set('127.0.0.1', $oldData);
        return false;
    }

    public static function getTable($type){
        switch ($type){
            case 'first':
                return TableManager::getInstance()->get(K::TABLE_FIRST_CACHE);
                break;
            case 'second':
                return TableManager::getInstance()->get(K::TABLE_SECOND_CACHE);
                break;
        }
    }
    public static function getDefaultQueryData($type)
    {
        switch ($type) {
            case 'first':
                $default = ['AAAAAAOjQP2gvWFC6aoSlYhJ42a10t20DLb0T+JHb29nbGVFYXJ0aFdpbi5leGU=', 'AAAAAAMSs4UoV6ZDn5rUNUcEUgl13h5qpOvMh4NHb29nbGVFYXJ0aFdpbi5leGU=', 'AAAAAAMKZ+z6qcxMrYHk9PvGsvY+Qna2YvF6AJBHb29nbGVFYXJ0aFdpbi5leGU=', 'AAAAAANdjPaPKLhPmoibCPRpFvBE+52iABUf0KhHb29nbGVFYXJ0aFdpbi5leGU='];
                $header = '{"user-agent":"GoogleEarth/7.1.8.3036(Windows;Microsoft Windows (6.2.9200.0);en;kml:2.2;client:Free;type:default)","connection":"Keep-Alive","accept":"application\/vnd.google-earth.kml+xml, application\/vnd.google-earth.kmz, image\/*, *\/*","cache-control":"no-store","content-type":"application\/octet-stream","accept-encoding":"gzip,deflate","accept-language":"en-us,en","accept-charset":"iso-8859-1,*,utf-8"}';
                $tmpQueryIndex = mt_rand(1, 20000) % count($default);
//               System::log($tmpQuery[$tmpQueryIndex],'use this data');
                $data = base64_decode($default[$tmpQueryIndex]);
                return [
                    'url' => 'https://kh.google.com/geauth',
                    'headers' => json_decode($header, true),
                    'data' => $data,
                ];
                break;
            case 'second':
                $default = ["AQAAAAMdrJRrrKpOyLASpJ9qoRq4M8TzO3z8gXddW65RxOERQAAK1XjI3bfB5EOLDw==", "AQAAAAM2dn6ok\/xCyJh0jJz9UqPP8hUmN+s+MOBJa6wHeB6LxAAK1Xh40bFsHNoAVQ==", "AQAAAAPWTRyZNSxBdJbAloapoUfVW0tLlEB60TN2+4A7QsKvGQAK1XjMWG7qzmW3cA==", "AQAAAAOyav32wbNCTpwgWd90JInDxLGYOY0qQ8MUTBTjvJiQ0AAK1XhWw2nOxb51HQ==", "AQAAAAOyav32wbNCTpwgWd90JInDxLGYOY0qQ8NP\/5SeeORh5gAK1Xj3a3ryGYXrOg==", "AQAAAAPWTRyZNSxBdJbAloapoUfVW0tLlEB60TOIpUOEtqgNgQAK1XhM1BrAsORAIQ==", "AQAAAAP5Kmkac7NC84\/2HBYdQj4GEsI7amzJzs\/YqVyqe\/BOQQAK1XimN7UQor9oGQ==", "AQAAAAPWTRyZNSxBdJbAloapoUfVW0tLlEB60TPwGtgfXGzlUgAK1XhgNrGwl5YtBQ==", "AQAAAAPWTRyZNSxBdJbAloapoUfVW0tLlEB60TOx46CT2poaiwAK1XigLtOwsZNapw==", "AQAAAAP\/hmtrccdNLIdIgzzo09ICTem92PtBdNg4e7dVa5ZUzwAK1Xh1PhLgJ\/6JMQ==", "AQAAAAPWTRyZNSxBdJbAloapoUfVW0tLlEB60TMQazfG0ndE1wAK1Xh\/eGD64ITI8A==", "AQAAAAPWTRyZNSxBdJbAloapoUfVW0tLlEB60TOypePoHEEFdwAK1XgtrfeNBV+VyQ==", "AQAAAAOR1MEvdgFHDZe+EvBAkpg53ft5lGKOfdQHx4\/NoBe1LQAK1Xh7JkhM6vXRlA==","AQAAAAP\/hmtrccdNLIdIgzzo09ICTem92PtBdNjQUu7letpt6QAK1XjMvMJb1meX1Q==", "AQAAAAP\/hmtrccdNLIdIgzzo09ICTem92PtBdNialAQGo4XyWQAK1XiFTgS\/x9sKfg==", "AQAAAAP3QRxLd01P9aT7fxBtg11hYoBtRZSje3w9CuMyVLYUzwAK1XgA0coh0RZPnQ==", "AQAAAAP3QRxLd01P9aT7fxBtg11hYoBtRZSje3x50p0FLo6BQwAK1XjTvh0pswy++Q==", "AQAAAANBg0tefWhPPZjkUnqeM\/kGi6NSNnyR2mgKvgeEp+p0MQAK1XhyGCLpj\/9LGA==", "AQAAAAP\/hmtrccdNLIdIgzzo09ICTem92PtBdNjklEseussXKwAK1XgtdDsov+JFtQ==", "AQAAAAP\/hmtrccdNLIdIgzzo09ICTem92PtBdNhP\/UEwZLCemwAK1XhZxs86qb8jMQ==", "AQAAAAMjHHEX9vdEabOTN3XbjitRSwqdyvqBOA4Qd5vGfU7+sQAK1Xh26o7LV2moUg==", "AQAAAAPxw5Rt6uFPoowlzrpqpQij9U\/84zaMgUFqO+gS0vMcXQAK1XjzPIXzQqsFuw==", "AQAAAAPTdgpkn3NIbb3OW9Gsf0v3OLzSvYvqWiTvyKAnZDf05QAK1Xjxm135WvCjCg==", "AQAAAAP3QRxLd01P9aT7fxBtg11hYoBtRZSje3yP1L9vYlHoWAAK1Xh57X66QO2Qcw==", "AQAAAAMVhKyDqcdGPozhUPp6xV\/76MIouuryjUzBmDBdMnXzKwAK1XhLic4s9URlgA==", "AQAAAAP6LtIYnehNtpu0zQt3tbaJ39+CjXizFhspaK0aOPxipwAK1XhWMZokP21Fmw==", "AQAAAAPtO04QHOxKdawoZIPAi6eLVr\/ceWwjJ9s9JWsfkgKoNQAK1XhA0CwCEzA9vg==", "AQAAAAOIfLpSsDxGSZ8PQrnMpdMUx9ecTS\/cFsvP4P1WOamaHgAK1XhNKM+85vuIQg==", "AQAAAANBzaYa7ZZKQ5vhfigTG+k8GR5lXKnLd9WxuT8pAztVxgAK1XixggJWCl+q4g==", "AQAAAAMGKz8dIH5Cn7GgFsK5l6pHHLVWfLaDgzqWg+iAH6TnpwAK1XiMQv\/PzZcRMw==", "AQAAAAPLI8ssEn1KQ5ti7dwylKQuNEqYiM0HK305kTU7aPD4zQAK1Xg8ZozPDWxruA==", "AQAAAAP27Z9kxxFN\/Jvo1aDFiuOS3VH8sR\/ECWWKj7jfCZFEzAAK1XgN\/Dq30SeDDw==", "AQAAAAMPvFs7f1dPVIPNI1v6HSbRDim13axE0x5cqwwToNhauQAK1XjSq5yM\/o29dw==", "AQAAAAO4vfae1fJEbLr4IMltJpuYjTRRpK39pdwvDb7SHB20mAAK1XgxLLFSiyQWfA=="];
                $cacheFile = System::config(K::KEY_CACHE_PATH) . '/session-ok';
                if (file_exists($cacheFile)) {
                    $shell = 'tail -n 1000 ' . $cacheFile;
                    exec($shell, $cache, $status);
                    if (!$status) {
                        $cache = array_filter($cache);
                        $cache = array_unique($cache);
                        foreach ($cache as $v) {
                            if (base64_decode($v) && strlen(base64_decode($v)) === 49) {
                                $tmpQuery[] = $v;
                            }
                        }
                    }
                }
                if (count($tmpQuery) < 10) {
                    shuffle($default);
                    foreach ($default as $k => $v) {
                        $tmpQuery[] = $v;
                        if ($k > 5) break;
                    }
                }
                $tmpQueryIndex = mt_rand(1, 20000) % count($tmpQuery);
//               System::log($tmpQuery[$tmpQueryIndex],'use this data');
                $data = base64_decode($tmpQuery[$tmpQueryIndex]);
                $header = '{"host":"kh.google.com","user-agent":"GoogleEarth/7.1.8.3036(Windows;Microsoft Windows (6.2.9200.0);en;kml:2.2;client:Free;type:default)","connection":"Keep-Alive","accept":"application/vnd.google-earth.kml+xml, application/vnd.google-earth.kmz, image/*, */*","content-type":"application/octet-stream","accept-encoding":"gzip,deflate","accept-language":"en-us,en","accept-charset":"iso-8859-1,*,utf-8","content-length":"49"}';
                return [
                    'url' => 'https://kh.google.com/geauth?ct=free',
                    'headers' => json_decode($header, true),
                    'data' => $data,
                ];
                break;
        }
    }

    public static function saveSession($session){
        $table=static::getTable('second');
        $key=static::getSessionKey($session);
        $table->set($key,['data' => base64_encode($session), 'sum' => 0, 'time' => time()]);
    }

    public static function test(){
        $default = static::getDefaultQueryData('second');
        System::log($default, 'test session query data');
        try {
            $saber=System::getSaber();
            $data = $saber->post($default['url'], $default['data'], ['headers' => $default['headers']]);
            $token = $data->getBody()->getContents();
            return ['token' => $token, 'code' => 200];
        } catch (\Throwable $exception) {
            return ['code' => $exception->getCode(), 'msg' => $exception->getMessage()];
        }
    }
}